#pragma once

#include "Engine/engine.h"

#define PLAYGROUND_ROWS 11
#define PLAYGROUND_COLS 15
#define PLAYGROUND_BORDER_LEFT 20
#define PLAYGROUND_BORDER_TOP 66
#define PLAYGROUND_BORDER_RIGHT 20
#define PLAYGROUND_BORDER_BOTTOM 18
#define FIELD_UNIT_WIDTH 40
#define FIELD_UNIT_HEIGHT 36
#define BOMBERMAN_BASE_SPEED 
enum TMoveDirection { N,NNE,NE,NEE,E,SEE,SE,SSE,S,SSW,SW,SWW,W,NWW,NW,NNW }; //(0-15 clockwise)

class Bomberman
{
public:
	Bomberman(int xloc, int yloc);
	~Bomberman();
	void Update();
	void move(int xloc, int yloc);
	void move_to(int xloc, int yloc);
	void move_to_direction(TMoveDirection dir, int speed);
	int getY();
	int getX();
	int getHeight();
	int getWidth();
	int getCenterX();
	int getCenterY();
	int getOffsetX();
	int getOffsetY();
	int getFieldCenterX();
	int getFieldCenterY();
private:
	int x,y;
	LPDIRECT3DTEXTURE9 texture;
};

class Item
{
public:
	Item(LPDIRECT3DTEXTURE9 t, int texnr, int subwidth, int subheight, int colnr, int rownr);
	~Item();
	void Draw();
	int col, row, tex_num, subitem_height, subitem_width;
private:
	LPDIRECT3DTEXTURE9 texture;
};

class Playground : public ITask
{
public:
	bool Start();
	void Update();
	void Stop();
	AUTO_SIZE;
private:
	LPDIRECT3DTEXTURE9 background;
	LPDIRECT3DTEXTURE9 foreground;

	Bomberman *bomberman;
	Item *field[PLAYGROUND_COLS][PLAYGROUND_ROWS];

	void move_up();
	void move_down();
	void move_right();
	void move_left();

	DWORD old_counter;
};
